# Estimate for updating a subscription

> For the complete machine-readable documentation index, see [llms.txt](https://apidocs.chargebee.com/llms.txt).


Returns an estimate for updating a subscription.

In the response,

-   `[subscription_estimate](/docs/api/estimates/estimate-object)`: The details of the changed subscription such as `status`, next billing date, and so on.
-   `[invoice_estimate](/docs/api/estimates/estimate-object)`:The details of the immediate invoice, if it is generated. An immediate invoice is not generated when:
    -   `end_of_term` parameter is true
    -   `prorate` parameter is `false`
    -   No changes are made to the plan item prices or addon item prices in `subscription_items`.
    -   For changes such as [quantity downgrades](https://www.chargebee.com/docs/proration.html#proration-mechanism_plan-quantity-downgrade-paid-invoice).
-   `[next_invoice_estimate](/docs/api/estimates/estimate-object)`:The details of the invoice to be generated later (if any) on the occasion that no immediate invoice has been generated.
-   `[credit_note_estimates](/docs/api/estimates/estimate-object)`:The list of credit notes (if any) generated during this operation.
-   `[unbilled_charge_estimates](/docs/api/estimates/estimate-object)`: The details of charges that have not been invoiced. This is returned only if the `invoice_immediately` parameter is set to `false`.

The following conditions must be met or **tax calculation** is ignored:

-   The `taxability` [attribute](/docs/api/customers/customer-object#taxability) for the customer is `true`.
-   Necessary parameters for tax calculation such as the following are passed: `billing_address`, `shipping_address`, `customer[vat_number]`

## Sample Request

#### cURL

```bash
curl  https://{site}.chargebee.com/api/v2/estimates/update_subscription_for_items \
     -u {site_api_key}:\
     -d "subscription[id]"="__test__8aspfRrLYaAEA" \
     -d "subscription_items[item_price_id][0]"="basic-USD" \
     -d "subscription_items[quantity][0]"=4 \
     -d "subscription_items[unit_price][0]"=1000 \
     -d invoice_immediately="true"
```

#### .NET

```dotnet
using ChargeBee.Api;
using ChargeBee.Models;

ApiConfig.Configure("{site}","{site_api_key}");
EntityResult result = Estimate.UpdateSubscriptionForItems()
		.SubscriptionId("__test__8aspfRrLYaAEA")
		.SubscriptionItemItemPriceId(0, "basic-USD")
		.SubscriptionItemQuantity(0, 4)
		.SubscriptionItemUnitPrice(0, 1000)
		.InvoiceImmediately(true)
		.Request();

Estimate estimate = result.Estimate;
```

#### Go

```go
package main
import (
    "fmt"
    "github.com/chargebee/chargebee-go/v3"
    estimateAction "github.com/chargebee/chargebee-go/v3/actions/estimate"
    "github.com/chargebee/chargebee-go/v3/models/estimate"
)
func main() {
    chargebee.Configure("{site_api_key}","{site}");
    res,err := estimateAction.UpdateSubscriptionForItems(&estimate.UpdateSubscriptionForItemsRequestParams{
        SubscriptionItems : []*estimate.UpdateSubscriptionForItemsSubscriptionItemParams{
            {
                ItemPriceId : "basic-USD",
                Quantity : chargebee.Int32(4),
                UnitPrice : chargebee.Int64(1000),
            },
        },
        Subscription : &estimate.UpdateSubscriptionForItemsSubscriptionParams{
            Id : "__test__8aspfRrLYaAEA",
        },
        InvoiceImmediately : chargebee.Bool(true),
    }).Request()
    if err != nil {
        fmt.Println(err)
    } else {
        Estimate := res.Estimate
    }
}
```

#### Go

```go
package main

import (
  "fmt"
  "github.com/chargebee/chargebee-go/v4"
)

func main() {
  config := &chargebee.ClientConfig{
    SiteName: "{site}",
    ApiKey: "{site_api_key}",
  }    
  client := chargebee.NewClient(config)
  req := &chargebee.EstimateUpdateSubscriptionForItemsRequest{
    SubscriptionItems : []*chargebee.EstimateUpdateSubscriptionForItemsSubscriptionItem{
        {
            ItemPriceId : "basic-USD",
            Quantity : chargebee.Int32(4),
            UnitPrice : chargebee.Int64(1000),
        },
    },
    Subscription : &chargebee.EstimateUpdateSubscriptionForItemsSubscription{
        Id : "__test__8aspfRrLYaAEA",
    },
    InvoiceImmediately : chargebee.Bool(true),
}
  res, err := client.Estimate.UpdateSubscriptionForItems(req)
      if err != nil {
        fmt.Println(err)
    } else {
        Estimate := res.Estimate
    }
}
```

#### Java

```java
import com.chargebee.*;
import com.chargebee.ListResult;
import com.chargebee.models.*;
import com.chargebee.models.enums.*;
import java.io.IOException;

public class Sample {

    public static void main(String args[]) throws IOException, Exception {
        Environment.configure("{site}", "{site_api_key}");
        Result result = Estimate.updateSubscriptionForItems()
            .subscriptionId("__test__8aspfRrLYaAEA")
            .subscriptionItemItemPriceId(0, "basic-USD")
            .subscriptionItemQuantity(0, 4)
            .subscriptionItemUnitPrice(0, 1000L)
            .invoiceImmediately(true)
            .request();

        Estimate estimate = result.estimate();
    }
}
```

#### Java

```java
import com.chargebee.v4.client.ChargebeeClient;
import com.chargebee.v4.models.estimate.Estimate;
import com.chargebee.v4.models.estimate.params.EstimateUpdateSubscriptionForItemsParams;
import com.chargebee.v4.models.estimate.responses.EstimateUpdateSubscriptionForItemsResponse;
import java.util.List;

public class EstimateUpdateSubscriptionForItems {

    public static void main(String[] args) {
        ChargebeeClient client = ChargebeeClient.builder()
            .apiKey("{site_api_key}")
            .siteName("{site}")
            .build();

        EstimateUpdateSubscriptionForItemsParams.SubscriptionParams subscriptionParams =
            EstimateUpdateSubscriptionForItemsParams.SubscriptionParams.builder()
                .id("__test__8aspfRrLYaAEA")
                .build();

        EstimateUpdateSubscriptionForItemsParams.SubscriptionItemsParams subscriptionItem0 =
            EstimateUpdateSubscriptionForItemsParams.SubscriptionItemsParams.builder()
                .itemPriceId("basic-USD")
                .quantity(4)
                .unitPrice(1000L)
                .build();

        List<EstimateUpdateSubscriptionForItemsParams.SubscriptionItemsParams> subscriptionItemsList =
            List.of(subscriptionItem0);

        EstimateUpdateSubscriptionForItemsParams params = EstimateUpdateSubscriptionForItemsParams.builder()
            .subscription(subscriptionParams)
            .subscriptionItems(subscriptionItemsList)
            .invoiceImmediately(true)
            .build();

        EstimateUpdateSubscriptionForItemsResponse response = client.estimates().updateSubscriptionForItems(params);

        Estimate estimate = response.getEstimate();
    }
}
```

#### Node.js

```node
import Chargebee from "chargebee";

const chargebee = new Chargebee({
    site: "{site}",
    apiKey: "{site_api_key}",
});

try {
    const result = await chargebee.estimate.updateSubscriptionForItems({
        subscription_items: [
            {
                item_price_id: "basic-USD",
                quantity: 4,
                unit_price: 1000
            }
        ],
        subscription: {
            id: "__test__8aspfRrLYaAEA"
        },
        invoice_immediately: true
    });

    console.log(result);
    const estimate = result.estimate;
} catch (err) {
    console.log(err);
}
```

#### PHP

```php
<?php

require __DIR__ . '/vendor/autoload.php';

use Chargebee\ChargebeeClient;

$chargebee = new ChargebeeClient(options: [
    "site" => "{site}",
    "apiKey" => "{site_api_key}",
]);
$result = $chargebee->estimate()->updateSubscriptionForItems([
    "subscription_items" => [
        [
            "item_price_id" => "basic-USD",
            "quantity" => 4,
            "unit_price" => 1000
        ]
    ],
    "subscription" => [
        "id" => "__test__8aspfRrLYaAEA"
    ],
    "invoice_immediately" => true
]);
$estimate = $result->estimate;
```

#### Python

```python
from chargebee import Chargebee

cb_client = Chargebee(api_key="{site_api_key}", site="{site}")
response = cb_client.Estimate.update_subscription_for_items(
    cb_client.Estimate.UpdateSubscriptionForItemsParams(
        subscription_items=[
            cb_client.Estimate.UpdateSubscriptionForItemsSubscriptionItemParams(
              item_price_id="basic-USD",
              quantity=4,
              unit_price=1000
            )
        ],
        subscription=cb_client.Estimate.UpdateSubscriptionForItemsSubscriptionParams(
            id="__test__8aspfRrLYaAEA"
        ),
        invoice_immediately=True
    )
)
estimate = response.estimate
```

#### Ruby

```ruby
require 'chargebee'

ChargeBee.configure(:site => "{site}",
  :api_key => "{site_api_key}")

result = ChargeBee::Estimate.update_subscription_for_items({
  :subscription => {
    :id => "__test__8aspfRrLYaAEA"
  },
  :subscription_items => [
    {
      :item_price_id => "basic-USD",
      :quantity => 4,
      :unit_price => 1000
    }
  ],
  :invoice_immediately => "true"
})

estimate = result.estimate
```

## Sample Response

```json
{
  "estimate": {
    "created_at": 1612964966,
    "credit_note_estimates": {},
    "invoice_estimate": {
      "amount_due": 3000,
      "amount_paid": 0,
      "credits_applied": 0,
      "currency_code": "USD",
      "customer_id": "__test__8asyKSOcecJ8PM",
      "date": 1612964966,
      "line_item_discounts": {},
      "line_item_taxes": {},
      "line_items": [
        {
          "amount": 3000,
          "customer_id": "__test__8asyKSOcecJ8PM",
          "date_from": 1612964966,
          "date_to": 1615384165,
          "description": "basic USD - Prorated Charges",
          "discount_amount": 0,
          "entity_id": "basic-USD",
          "entity_type": "plan_item_price",
          "id": "li___test__8asyKSOcecf6PY",
          "is_taxed": false,
          "item_level_discount_amount": 0,
          "object": "line_item",
          "pricing_model": "per_unit",
          "quantity": 3,
          "subscription_id": "__test__8asyKSOcecNUPP",
          "tax_amount": 0,
          "unit_amount": 1000
        },
        {..}
      ],
      "object": "invoice_estimate",
      "price_type": "tax_exclusive",
      "recurring": true,
      "round_off_amount": 0,
      "sub_total": 3000,
      "taxes": {},
      "total": 3000
    },
    "object": "estimate",
    "subscription_estimate": {
      "currency_code": "USD",
      "id": "__test__8asyKSOcecNUPP",
      "next_billing_at": 1615384165,
      "object": "subscription_estimate",
      "status": "active"
    }
  }
}
```

## URL Format

**POST** https://[site].chargebee.com/api/v2/estimates/update_subscription_for_items

## Input Parameters

- `changes_scheduled_at` (optional, timestamp(UTC) in seconds)
  When `change_option` is set to `specific_date`, then set the date/time at which the subscription change is to happen or has happened.
  
  **Constraints**
  
  -   Do not pass this parameter along with `reactivate_from`.
  -   The `changes_scheduled_at` parameter does not apply to `auto_collection`, `shipping_address`, and `po_number`; these parameters take effect **immediately** when scheduling a subscription update.
  
  **Backdated changes**  
  `changes_scheduled_at`can be set to a value in the past. This is called backdating the subscription change and is performed when the subscription change has already been provisioned but its billing has been delayed. Backdating is allowed only when the following prerequisites are met:
  
  -   Backdating must be enabled for subscription change operations.
  -   Only the following changes can be backdated:
      -   Changes in the recurring items or their prices.
      -   Addition of non-recurring items.
  -   Subscription `status` is `active`, `cancelled`, or `non_renewing`.
  -   The current day of the month does not exceed the limit set in Chargebee for backdating subscription change. This limit is typically the day of the month by which the accounting for the previous month must be closed.
  -   The date is on or after `current_term_start`.
  -   The date is on or after the last date/time any of the following changes were made:
      -   Changes in the recurring items or their prices.
      -   Addition of non-recurring items.
  -   The date is not more than duration X into the past where X is the billing period of the plan. For example, if the period of the plan in the subscription is 2 months and today is 14th April, `changes_scheduled_at` cannot be earlier than 14th February.

- `change_option` (optional, enumerated string)
  Specifies the effective date for the subscription change.
  Possible enum values:
    - `immediately`
      The change is carried out immediately.
    - `end_of_term`
      The change is carried out at the end of the current billing cycle of the subscription.
    - `specific_date`
      Executes the change on a specified date. The change occurs as of the date/time defined in `changes_scheduled_at`.

- `mandatory_items_to_remove` (optional, string, max chars=100)
  Item ids of [mandatorily attached addons](/docs/api/attached_items) that are to be removed from the subscription.

- `replace_items_list` (optional, boolean, default=false)
  If `true` then the existing `subscription_items` list for the subscription is replaced by the one provided. If `false` then the provided `subscription_items` list gets added to the existing list.

- `invoice_date` (optional, timestamp(UTC) in seconds)
  The document date displayed on the invoice PDF. The default value is the current date. Provide this value to backdate the invoice. Backdating an invoice is done for reasons such as booking revenue for a previous date or when the subscription is effective as of a past date. Moreover, if `create_pending_invoices` is set to `true` , and if the site is configured to set invoice dates to date of closing, then upon invoice closure, this date is changed to the invoice closing date. taxes and line\_item\_taxes are computed based on the tax configuration as of `invoice_date`. When passing this parameter, the following prerequisites must be met:
  
  -   `invoice_date` must be in the past.
  -   `invoice_date` is not more than one calendar month into the past. For example, if today is 13th January, then you cannot pass a value that is earlier than 13th December.
  -   It is not earlier than `changes_scheduled_at`, `reactivate_from`, or `trial_end`.
  -   `invoice_immediately` is `true`. .

- `billing_cycles` (optional, integer, min=0)
  Billing cycles set for plan-item price is used by default.

- `terms_to_charge` (optional, integer, min=1)
  The number of subscription billing cycles to [invoice in advance](https://www.chargebee.com/docs/advance-invoices.html). If a new term is started for the subscription due to this API call, then `terms_to_charge` is inclusive of this new term. See description for the `force_term_reset` parameter to learn more about when a subscription term is reset.

- `reactivate_from` (optional, timestamp(UTC) in seconds)
  If the subscription `status` is `cancelled` and it is being reactivated via this operation, this is the date/time at which the subscription should be reactivated. **Note:** It is recommended not to pass this parameter along with `changed_scheduled_at`. `reactivate_from` can be backdated (set to a value in the past). Use backdating when the subscription has been reactivated already but its billing has been delayed. Backdating is allowed only when the following prerequisites are met:
  
  -   Backdating must be enabled for subscription reactivation operations.
  -   The current day of the month does not exceed the limit set in Chargebee for backdating subscription change. This limit is the day of the month by which the accounting for the previous month must be closed.
  -   The date is on or after the last date/time any of the product catalog items of the subscription were changed.
  -   The date is not more than duration X into the past where X is the billing period of the plan. For example, if the period of the plan in the subscription is 2 months and today is 14th April, `changes_scheduled_at` cannot be earlier than 14th February. .

- `billing_alignment_mode` (optional, enumerated string)
  Override the [billing alignment mode](https://www.chargebee.com/docs/calendar-billing.html#alignment-of-billing-date) chosen for the site for calendar billing. Only applicable when using calendar billing.
  Possible enum values:
    - `immediate`
      Subscription period will be aligned with the configured billing date immediately, with credits or charges raised accordingly..
    - `delayed`
      Subscription period will be aligned with the configured billing date at the next renewal.

- `coupon_ids` (optional, string, max chars=100)
  List of coupons to be applied to this subscription. You can provide coupon ids or [coupon codes](/docs/api/coupon_codes) .

- `replace_coupon_list` (optional, boolean, default=false)
  If `true` then the existing `coupon_ids` list for the subscription is replaced by the one provided. If `false` then the provided list gets added to the existing `coupon_ids` .

- `prorate` (optional, boolean)
  -   When `true`: [Prorated credits or charges](https://www.chargebee.com/docs/2.0/proration.html#proration-mechanism) are created as applicable for this change.
  -   When `false`: The subscription is changed without creating any credits or charges.
  -   When not provided, the value configured in the [site settings](https://www.chargebee.com/docs/2.0/proration.html#proration-for-subscription-change) is considered.
  
  **Caveat**
  
  For further changes within the same billing term, when `prorate` is set to `true`, **credits** are **not created** when **all** the conditions below hold true:
  
  An immediate previous change was made
  
  -   with `prorate` set to `false` and
  -   no changes were made to the subscription's billing term and
  -   a change was made to either the subscription's items or their prices.

- `end_of_term` (optional, boolean, default=false)
  **Deprecated**
  
  -   Use `change_option` instead.
  -   If you pass this parameter along with `change_option`, then `change_option` wins.
  
  Set this to true if you want the update to be applied at the end of the current subscription billing cycle.

- `force_term_reset` (optional, boolean, default=false)
  Say the subscription has the renewal date as 28th of every month. When the plan-item price of the subscription is set to one that has the same billing period as the current plan-item price, the subscription change does not change the term. In other words, the subscription still renews on the 28th. Passing this parameter as `true` will have the subscription reset its term to the current date (provided `end_of_term` is false). **Note**: When the new plan-item price has a billing period different from the current plan-item price of the subscription, the term is always reset, regardless of the value passed for this parameter.

- `reactivate` (optional, boolean)
  Applicable only for `cancelled` subscriptions. When passed as `true` , the canceled subscription is activated; otherwise subscription changes are made without changing its `status`. If not passed, subscription will be activated only if `subscription_items` is passed.

- `include_delayed_charges` (optional, boolean, default=false)
  If true, all the unbilled charges will be included for the invoice estimate.

- `use_existing_balances` (optional, boolean, default=true)
  The generated invoice\_estimate/next\_invoice\_estimate will include all the balances - Promotional Credits, Refundable Credits, and Excess Payments - if any. If you don't want these balances to be included you can specify 'false' for the parameter _use\_existing\_balances_ .

- `invoice_immediately` (optional, boolean)
  If there are charges raised immediately for the subscription, this parameter specifies whether those charges are to be invoiced immediately or added to [unbilled charges](https://www.chargebee.com/docs/unbilled-charges.html). The default value is as per the [site settings](https://www.chargebee.com/docs/unbilled-charges.html#configuration) .
  
  **Note:** `invoice_immediately` only affects charges that are raised at the time of execution of this API call. Any charges scheduled to be raised in the future are not affected by this parameter.
  
  .

- `invoice_usages` (optional, boolean, default=false)
  Setting this attribute to `true` will invoice the overages for the metered item during subscription changes .

- `subscription` (optional, string)
  Parameters for subscription
  - `id` (required, string, max chars=50)
    A unique and immutable identifier for the subscription. If not provided, it is autogenerated.
  - `start_date` (optional, timestamp(UTC) in seconds)
    The new start date of a `future` subscription. Applicable only for `future` subscriptions.
  - `trial_end` (optional, timestamp(UTC) in seconds)
    The time at which the trial has ended or will end for the subscription. This is only allowed when the subscription `status` is `future` , `in_trial` , or `cancelled`. Also, the value must not be earlier than `changes_scheduled_at` or `start_date`. **Note**: This parameter can be backdated (set to a value in the past) only when the subscription is in `cancelled` or `in_trial` `status`. Do this to keep a record of when the trial ended in case it ended at some point in the past. When `trial_end` is backdated, the subscription immediately goes into `active` or `non_renewing` status.
  - `auto_collection` (optional, enumerated string)
    Defines whether payments need to be collected automatically for this subscription. Overrides customer's auto-collection property.
    Possible enum values:
      - `on`
        Whenever an invoice is created for this subscription, an automatic charge will be attempted on the payment method available.
      - `off`
        Automatic collection of charges will not be made for this subscription. Use this for offline payments.
  - `offline_payment_method` (optional, enumerated string)
    The preferred offline payment method for the subscription.
    Possible enum values:
      - `no_preference`
        No Preference
      - `cash`
        Cash
      - `check`
        Check
      - `bank_transfer`
        Bank Transfer
      - `ach_credit`
        ACH Credit
      - `sepa_credit`
        SEPA Credit
      - `boleto`
        Boleto
      - `us_automated_bank_transfer`
        US Automated Bank Transfer
      - `eu_automated_bank_transfer`
        EU Automated Bank Transfer
      - `uk_automated_bank_transfer`
        UK Automated Bank Transfer
      - `jp_automated_bank_transfer`
        JP Automated Bank Transfer
      - `mx_automated_bank_transfer`
        MX Automated Bank Transfer
      - `custom`
        Custom
  - `free_period` (optional, integer, min=1)
    The period of time by which the first term of the subscription is to be extended free-of-charge. The value must be in multiples of free\_period\_unit.
  - `free_period_unit` (optional, enumerated string)
    The unit of time in multiples of which the free\_period parameter is expressed. The value must be equal to or lower than the [period\_unit](/docs/api/v2/pcv-1/plans/create-a-plan#period_unit) attribute of the [plan](/docs/api/v2/pcv-1/subscriptions/create-a-subscription#plan_id) chosen.
    Possible enum values:
      - `day`
        Charge based on day(s)
      - `week`
        Charge based on week(s)
      - `month`
        Charge based on month(s)
      - `year`
        Charge based on year(s)
  - `trial_end_action` (optional, enumerated string)
    Applicable only when [End-of-trial Action](https://www.chargebee.com/docs/1.0/trial_periods_hidden.html#how-to-define-the-end-of-trial-actions-for-subscriptions) has been enabled for the site. Whenever the subscription has a trial period, this attribute (parameter) is returned (required) and specifies the operation to be carried out for the subscription once the trial ends.
    Possible enum values:
      - `site_default`
        This is the default value. The action [configured for the site](https://www.chargebee.com/docs/1.0/trial_periods_hidden.html#how-to-define-the-end-of-trial-actions-for-subscriptions) at the time when the trial ends, takes effect.
      - `plan_default`
        The action [configured for the site](https://www.chargebee.com/docs/1.0/trial_periods_hidden.html#how-to-define-the-end-of-trial-actions-for-subscriptions) at the time when the trial ends, takes effect.
      - `activate_subscription`
        The subscription activates and charges are raised for non-metered items.
      - `cancel_subscription`
        The subscription cancels.

- `billing_address` (optional, string)
  Parameters for billing\_address
  - `line1` (optional, string, max chars=150)
    Address line 1
  - `line2` (optional, string, max chars=150)
    Address line 2
  - `line3` (optional, string, max chars=150)
    Address line 3
  - `city` (optional, string, max chars=50)
    The name of the city.
  - `state_code` (optional, string, max chars=50)
    The [ISO 3166-2 state/province code](https://www.iso.org/obp/ui/#search/code) without the country prefix. Currently supported for USA, Canada and India. For instance, for Arizona (USA), set `state_code` as `AZ` (not `US-AZ` ). For Tamil Nadu (India), set as `TN` (not `IN-TN` ). For British Columbia (Canada), set as `BC` (not `CA-BC` ).
  - `zip` (optional, string, max chars=20)
    Zip or postal code. The number of characters is validated according to the rules [specified here](https://chromium-i18n.appspot.com/ssl-address) .
  - `country` (optional, string, max chars=50)
    The billing address country of the customer. Must be one of [ISO 3166 alpha-2 country code](https://www.iso.org/iso-3166-country-codes.html) .
    
    **Note**: If you enter an invalid country code, the system will return an error.
    
    **Brexit**
    
    If you have enabled [EU VAT](https://www.chargebee.com/docs/eu-vat.html) in 2021 or later, or have [manually enable](https://www.chargebee.com/docs/brexit.html#what-needs-to-be-done-in-chargebee) the Brexit configuration, then `XI` (the code for **United Kingdom - Northern Ireland**) is available as an option.
  - `validation_status` (optional, enumerated string, default=not_validated)
    The address verification status.
    Possible enum values:
      - `not_validated`
        Address is not yet validated.
      - `valid`
        Address was validated successfully.
      - `partially_valid`
        The address is valid for taxability but has not been validated for shipping.
      - `invalid`
        Address is invalid.

- `shipping_address` (optional, string)
  Parameters for shipping\_address
  - `line1` (optional, string, max chars=150)
    Address line 1
  - `line2` (optional, string, max chars=150)
    Address line 2
  - `line3` (optional, string, max chars=150)
    Address line 3
  - `city` (optional, string, max chars=50)
    The name of the city.
  - `state_code` (optional, string, max chars=50)
    The [ISO 3166-2 state/province code](https://www.iso.org/obp/ui/#search/code) without the country prefix. Currently supported for USA, Canada and India. For instance, for Arizona (USA), set `state_code` as `AZ` (not `US-AZ` ). For Tamil Nadu (India), set as `TN` (not `IN-TN` ). For British Columbia (Canada), set as `BC` (not `CA-BC` ).
  - `zip` (optional, string, max chars=20)
    Zip or postal code. The number of characters is validated according to the rules [specified here](https://chromium-i18n.appspot.com/ssl-address) .
  - `country` (optional, string, max chars=50)
    The billing address country of the customer. Must be one of [ISO 3166 alpha-2 country code](https://www.iso.org/iso-3166-country-codes.html) .
    
    **Note**: If you enter an invalid country code, the system will return an error.
    
    **Brexit**
    
    If you have enabled [EU VAT](https://www.chargebee.com/docs/eu-vat.html) in 2021 or later, or have [manually enable](https://www.chargebee.com/docs/brexit.html#what-needs-to-be-done-in-chargebee) the Brexit configuration, then `XI` (the code for **United Kingdom - Northern Ireland**) is available as an option.
  - `validation_status` (optional, enumerated string, default=not_validated)
    The address verification status.
    Possible enum values:
      - `not_validated`
        Address is not yet validated.
      - `valid`
        Address was validated successfully.
      - `partially_valid`
        The address is valid for taxability but has not been validated for shipping.
      - `invalid`
        Address is invalid.

- `customer` (optional, string)
  Parameters for customer
  - `vat_number` (optional, string, max chars=20)
    VAT number of this customer. If not provided then taxes are not calculated for the estimate. Applicable only when taxes are configured for the EU or UK region. VAT validation is not done for this.
  - `vat_number_prefix` (optional, string, max chars=10)
    An overridden value for the first two characters of the [full VAT number](https://en.wikipedia.org/wiki/VAT_identification_number). Only applicable specifically for customers with `[billing_address](/docs/api/customers/customer-object#billing_address)`
    
    `country` as `XI` (which is **United Kingdom - Northern Ireland** ).
    
    When you have enabled [EU VAT](https://www.chargebee.com/docs/eu-vat.html) in 2021 or have [manually enabled](https://www.chargebee.com/docs/brexit.html#what-needs-to-be-done-in-chargebee) the Brexit configuration, you have the option of setting `[billing_address](/docs/api/customers/customer-object#billing_address)`
    
    `country` as `XI`. That's the code for **United Kingdom - Northern Ireland**. The first two characters of the VAT number in such a case is `XI` by default. However, if the VAT number was registered in UK, the value should be `GB`. Set `vat_number_prefix` to `GB` for such cases.
  - `registered_for_gst` (optional, boolean)
    Confirms that a customer is registered under GST. If set to `true` then the [Reverse Charge Mechanism](https://www.chargebee.com/docs/australian-gst.html#reverse-charge-mechanism) is applicable. This field is applicable only when Australian GST is configured for your site.

- `billing_override` (optional, long)
  Parameters for billing\_override
  - `max_excess_payment_usage` (optional, long, min=-1)
    Maximum amount of [excess payments](/docs/api/customers/customer-object#excess_payments) that can be automatically applied to a single invoice associated with this subscription.
    
    **Supported values:**
    
    -   `-1`: Set to `-1` to reset the subscription-level limit. In this case, the site-level configuration will apply, whether it is configured to Auto Apply or Do Not Auto Apply excess payments.
    -   `0`: Disable auto-application for the subscription. No excess payments will be automatically applied to invoices.
    -   Any positive value: Specifies the maximum amount of excess payments that can be automatically applied to a single invoice for this subscription.
  - `max_refundable_credits_usage` (optional, long, min=-1)
    Maximum amount of [refundable credits](/docs/api/customers/customer-object#refundable_credits) that can be automatically applied to a single invoice associated with this subscription.
    
    **Supported values:**
    
    -   `-1`: Set to `-1` to reset the subscription-level limit. In this case, the site-level configuration will apply, whether it is configured to Auto Apply or Do Not Auto Apply refundable credits.
    -   `0`: Disable auto-application for the subscription. No refundable credits will be automatically applied to invoices.
    -   Any positive value: Specifies the maximum amount of refundable credits that can be automatically applied to a single invoice for this subscription.

- `subscription_items` (optional, array)
  Parameters for subscription\_items
  - `item_price_id` (required, string, max chars=100)
    The unique identifier of the item price.
  - `quantity` (optional, integer)
    The quantity of the item purchased
  - `quantity_in_decimal` (optional, string, max chars=33)
    The decimal representation of the quantity of the item purchased. Can be provided for quantity-based item prices and only when [multi-decimal pricing](/docs/api/getting-started) is enabled.
  - `unit_price` (optional, in cents)
    The price/per unit price of the item. When not provided, [the value set](/docs/api/item_prices/item-price-object) for the item price is used. This is only applicable when the `pricing_model` of the item price is `flat_fee` or `per_unit`. Also, it is only allowed when [price overriding](https://www.chargebee.com/docs/price-override.html) is enabled for the site. The value depends on the type of currency. If `changes_scheduled_at` is in the past and a `unit_price` is not passed, then the item price's current unit price is considered even if the item price did not exist on the date as of when the change is scheduled.
  - `unit_price_in_decimal` (optional, string, max chars=39)
    When [price overriding](https://www.chargebee.com/docs/price-override.html) is enabled for the site, the price or per-unit price of the item can be set here. The [value set for the item price](/docs/api/item_prices/item_price-object#price) is used by default. Provide the value as a decimal string in major units of the currency. Can be provided only when [multi-decimal pricing](/docs/api/getting-started) is enabled. If `changes_scheduled_at` is in the past and a `unit_price_in_decimal` is not passed, then the item price's current unit price is considered even if the item price did not exist on the date as of when the change is scheduled.
  - `billing_cycles` (optional, integer)
    For the plan-item price: the value determines the number of billing cycles the subscription runs before canceling automatically. If not provided, then [the value set](/docs/api/item_prices/item-price-object) for the plan-item price is used.
    
    For addon-item prices: If [addon billing cycles](https://www.chargebee.com/docs/2.0/addons-billingcycle.html) are enabled then this is the number of subscription billing cycles for which the addon is included. If not provided, then [the value set under attached addons](/docs/api/attached_items/attached-item-object) is used. Further, if that value is not provided, then [the value set for the addon-item price](/docs/api/item_prices/item-price-object) is used.
  - `trial_end` (optional, timestamp(UTC) in seconds)
    The date/time when the trial period of the item ends. Applies to plan-items and--when [enabled](https://www.chargebee.com/docs/2.0/addons-trial.html) --addon-items as well.
  - `service_period_days` (optional, integer)
    The service period of the item in days from the day of charge.
  - `charge_on_event` (optional, enumerated string)
    When `charge_on_option` option is set to `on_event` , this parameter specifies the event at which the charge-item is applied to the subscription. This parameter only applies to charge-items.
    Possible enum values:
      - `subscription_creation`
        the time of creation of the subscription.
      - `subscription_trial_start`
        the time when the trial period of the subscription begins.
      - `plan_activation`
        same as subscription activation, but also includes the case when the plan-item of the subscription is changed.
      - `subscription_activation`
        the moment a subscription enters an `active` or `non-renewing` state. Also includes reactivations of canceled subscriptions.
      - `contract_termination`
        when a contract term is [terminated](/docs/api/subscriptions/cancel-subscription-for-items#contract_term_cancel_option) .
  - `charge_once` (optional, boolean)
    Indicates if the charge-item is to be charged only once or each time the `charge_on_event` occurs. This parameter only applies to charge-items.
  - `charge_on_option` (optional, enumerated string)
    Indicates when the charge-item is to be charged. This parameter only applies to charge-items.
    Possible enum values:
      - `immediately`
        The item is charged immediately on being added to the subscription.
      - `on_event`
        The item is charged at the occurrence of the event specified as `charge_on_event` .
  - `description` (optional, string, max chars=500)
    **Limited availability**
    
    Subscription-level item descriptions are available only on sites where this feature is enabled. Please reach out to the Chargebee [support](https://www.chargebee.com/docs/billing/2.0/kb/getting-started/how-to-contact-chargebees-support-team?utm_source=docs_api&utm_medium=content&utm_campaign=support) to enable this feature.
    
    A description for this item that applies only to this subscription. When set, it is used on the customer-facing invoice instead of the description configured for the item price, and is returned as `entity_description` on the invoice [line item](/docs/api/invoices/invoice-object#invoice_line_items).
    
    Omit this parameter to retain the description currently stored for the item. Pass an empty value to remove it, after which the description configured for the item price is used.
    
    **Constraints**
    
    -   Maximum 500 characters.
    -   Whether a description is shown on the invoice at all continues to be controlled by the item price's [show\_description\_in\_invoices](/docs/api/item_prices#show_description_in_invoices) setting. This parameter determines which description is shown, not whether one is shown.
  - `proration_type` (optional, enumerated string)
    **Note** Applicable only for item prices with:
    
    -   `[item_type](/docs/api/item_prices/item_price-object#item_type)` = `addon`.
    -   `[pricing_model](/docs/api/item_prices/item_price-object#pricing_model)` = `per_unit`.
    
    Specifies how to manage charges or credits for the addon item price for this subscription update estimate. You may use this parameter only if the change to the subscription takes effect `[immediately](/docs/api/subscriptions/update-subscription-for-items#change_option)`.
    
    **Note**: If you don't provide a value, Chargebee determines the proration logic based on the following precedence: this parameter > `[prorate](/docs/api/estimates/estimate-object)` parameter > `[item_price.proration_type](/docs/api/item_prices/item_price-object#proration_type)`
    
    > [site-wide proration](https://www.chargebee.com/docs/2.0/proration.html#proration-for-subscription-change) setting.
    Possible enum values:
      - `full_term`
        Charge the full price of the addon or give the full credit. Don't apply any proration.
      - `partial_term`
        Prorate the charges or credits for the rest of the current term.
      - `none`
        Don't apply any charges or credits for the addon.

- `discounts` (optional, array)
  Parameters for discounts
  - `apply_on` (optional, enumerated string)
    The amount on the invoice to which the discount is applied.
    Possible enum values:
      - `invoice_amount`
        The discount is applied to the invoice `sub_total` .
      - `specific_item_price`
        The discount is applied to the `invoice.line_item.amount` that corresponds to the item price specified by `item_price_id` .
  - `duration_type` (required, enumerated string)
    Specifies the time duration for which this discount is attached to the subscription.
    Possible enum values:
      - `one_time`
        The discount stays attached to the subscription till it is applied on an invoice **once**. It is removed after that from the subscription.
      - `forever`
        The discount is attached to the subscription and applied on the invoices till it is [explicitly removed](/docs/api/subscriptions/update-subscription-for-items#discounts_operation_type) .
      - `limited_period`
        The discount is attached to the subscription and applied on the invoices for a limited duration. This duration starts from the point it is applied to an invoice for the first time and expires after a period specified by `period` and `period_unit` .
  - `percentage` (optional, double)
    The percentage of the original amount that should be deducted from it.
  - `amount` (optional, in cents)
    The value of the discount. [The format of this value](/docs/api/currencies) depends on the kind of currency.
  - `period` (optional, integer)
    The duration of time for which the discount is attached to the subscription, in `period_units`. Applicable only when `duration_type` is `limited_period`.
  - `period_unit` (optional, enumerated string)
    The unit of time for `period`. Applicable only when `duration_type` is `limited_period`.
    Possible enum values:
      - `day`
        A period of 24 hours.
      - `week`
        A period of 7 days.
      - `month`
        A period of 1 calendar month.
      - `year`
        A period of 1 calendar year.
  - `included_in_mrr` (optional, boolean)
    The discount is included in MRR calculations for your site. This attribute is only applicable when `duration_type` is `one_time` and when the [feature is enabled](https://www.chargebee.com/docs/reporting.html#dashboards_flexible-mrr-calculation) in Chargebee. Also, If the [site-level setting](https://www.chargebee.com/docs/reporting.html#chart_flexible-mrr-calculation) is to exclude one-time discounts from MRR calculations, this value is always returned `false`.
  - `item_price_id` (optional, string, max chars=100)
    The [id of the item price](/docs/api/subscriptions/subscription-object#subscription_items_item_price_id) in the subscription to which the discount is to be applied. Relevant only when `apply_on` = `specific_item_price`.
  - `quantity` (optional, integer)
    Specifies the number of free units provided for the item, without affecting the total quantity sold
  - `operation_type` (required, enumerated string)
    The operation to be carried out for the discount.
    Possible enum values:
      - `add`
        The discount is attached to the subscription.
      - `remove`
        The discount (given by `discounts[id]` ) is removed from the subscription. Subsequent invoices will no longer have the discount applied. **Tip:** If you want to replace a discount, `remove` it and `add` another in the same API call.
  - `id` (optional, string, max chars=50)
    An immutable unique id for the discount. It is always auto-generated.

- `item_tiers` (optional, array)
  Parameters for item\_tiers
  - `item_price_id` (optional, string, max chars=100)
    The id of the item price for which the tier price is being overridden.
  - `starting_unit` (optional, integer)
    The lowest value in the quantity tier.
  - `ending_unit` (optional, integer)
    The highest value in the quantity tier.
  - `price` (optional, in cents)
    The overridden price of the tier. The value depends on the [type of currency](/docs/api/estimates) .
  - `starting_unit_in_decimal` (optional, string, max chars=33)
    The decimal representation of the lowest value of quantity in this tier. This is zero for the lowest tier. For all other tiers, it is the same as `ending_unit_in_decimal` of the next lower tier. Returned only when the pricing\_model is `tiered` , `volume` or `stairstep` and [multi-decimal pricing](/docs/api/getting-started) is enabled.
  - `ending_unit_in_decimal` (optional, string, max chars=33)
    The decimal representation of the highest value of quantity in this tier. This attribute is not applicable for the highest tier. For all other tiers, it must be equal to the `starting_unit_in_decimal` of the next higher tier. Returned only when the pricing\_model is `tiered` , `volume` or `stairstep` and [multi-decimal pricing](/docs/api/getting-started) is enabled.
  - `price_in_decimal` (optional, string, max chars=39)
    The decimal representation of the per-unit price for the tier when the `pricing_model` is `tiered` or `volume`. When the `pricing_model` is `stairstep` , it is the decimal representation of the total price for the item. The value is in major units of the currency. Returned when the plan is quantity-based and [multi-decimal pricing](/docs/api/getting-started) is enabled.
  - `pricing_type` (optional, enumerated string)
    Pricing type for the tier.
    Possible enum values:
      - `per_unit`
        Indicates that the tier pricing is based on individual units. Customers are charged a fixed price per unit. For example, if the price per unit is $2 and the customer consumes 150 units, they will be charged $300 (150 × $2).
      - `flat_fee`
        Indicates that the tier pricing is a flat fee, applied to the entire tier regardless of the number of units consumed. For the **stairstep** pricing model, `pricing_type` will be set to `flat_fee` by default. For example, if the flat fee for a tier is $100, the customer pays $100 whether they consume 1 unit or the maximum number of units within that tier.
      - `package`
        Indicates that the tier pricing is based on a package of units. Customers are charged for each block or package of units. For example, if the package size is 100 units and the cost per block is $20 consuming 400 units will result in a charge of $80 (4 × $20).
  - `package_size` (optional, integer)
    Package size for the tier when pricing type is `package`. Specify the number of units that make up one package. For example, if 1000 API hits are grouped into a single package, set the package size to 1000.

## Returns

- `estimate` (Estimate object)
  Resource object representing estimate
